# wxExtHelpController Class Reference
[Help]

`#include <wx/generic/helpext.h>`

Inheritance diagram for wxExtHelpController:
[legend]

## Detailed Description

This class implements help via an external browser.

It requires the name of a directory containing the documentation and a file mapping numerical Section numbers to relative URLS.

The map file contains two or three fields per line: numeric_id relative_URL [; comment/documentation]

The numeric_id is the id used to look up the entry in DisplaySection()/DisplayBlock(). The relative_URL is a filename of an html file, relative to the help directory. The optional comment/documentation field (after a ';') is used for keyword searches, so some meaningful text here does not hurt. If the documentation itself contains a ';', only the part before that will be displayed in the listbox, but all of it used for search.

Lines starting with ';' will be ignored.

##

Library: wxAdvanced

Category: Help

See also:
  wxHelpController

## Public Member Functions
| wxExtHelpController (wxWindow *parentWindow=NULL)
virtual | ~wxExtHelpController ()
virtual void | SetViewer (const wxString &viewer=wxEmptyString, long flags=wxHELP_NETSCAPE)
| Tell it which browser to use.
virtual bool | Initialize (const wxString &dir)
| This must be called to tell the controller where to find the documentation.
virtual bool | LoadFile (const wxString &file=wxEmptyString)
| If file is "", reloads file given in Initialize.
virtual bool | DisplayContents (void)
| Display list of all help entries.
virtual bool | DisplaySection (int sectionNo)
| Display help for id sectionNo.
virtual bool | DisplaySection (const wxString &section)
| Display help for id sectionNo -- identical with DisplaySection().
virtual bool | DisplayBlock (long blockNo)
| Display help for URL (using DisplayHelp) or keyword (using KeywordSearch).
virtual bool | KeywordSearch (const wxString &k, wxHelpSearchMode mode=wxHELP_SEARCH_ALL)
| Search comment/documentation fields in map file and present a list to chose from.
virtual bool | Quit ()
| Does nothing.
virtual void | OnQuit ()
| Does nothing.
virtual bool | DisplayHelp (const wxString &)
| Call the browser using a relative URL.
virtual void | SetFrameParameters (const wxString &title, const wxSize &size, const wxPoint &pos=wxDefaultPosition, bool newFrameEachTime=false)
| Allows one to override the default settings for the help frame.
virtual wxFrame * | GetFrameParameters (wxSize *size=NULL, wxPoint *pos=NULL, bool *newFrameEachTime=NULL)
| Obtains the latest settings used by the help frame and the help frame.

List of all members.

## Constructor & Destructor Documentation

wxExtHelpController::wxExtHelpController | ( | wxWindow * | parentWindow = `NULL` | ) |

virtual wxExtHelpController::~wxExtHelpController | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual bool wxExtHelpController::DisplayBlock | ( | long | blockNo | ) | `[virtual]`

Display help for URL (using DisplayHelp) or keyword (using KeywordSearch).

Returns:
  true on success

Reimplemented from wxHelpController.

virtual bool wxExtHelpController::DisplayContents | ( | void |  | ) | `[virtual]`

Display list of all help entries.

Returns:
  true on success

Reimplemented from wxHelpController.

virtual bool wxExtHelpController::DisplayHelp | ( | const wxString & |  | ) | `[virtual]`

Call the browser using a relative URL.

virtual bool wxExtHelpController::DisplaySection | ( | const wxString & | section | ) | `[virtual]`

Display help for id sectionNo -- identical with DisplaySection().

Returns:
  true on success

Reimplemented from wxHelpController.

virtual bool wxExtHelpController::DisplaySection | ( | int | sectionNo | ) | `[virtual]`

Display help for id sectionNo.

Returns:
  true on success

Reimplemented from wxHelpController.

virtual wxFrame* wxExtHelpController::GetFrameParameters | ( | wxSize * | size = `NULL`,
|  | wxPoint * | pos = `NULL`,
|  | bool * | newFrameEachTime = `NULL` |
| ) |  |  | `[virtual]`

Obtains the latest settings used by the help frame and the help frame.

virtual bool wxExtHelpController::Initialize | ( | const wxString & | dir | ) | `[virtual]`

This must be called to tell the controller where to find the documentation.

If a locale is set, look in file/localename, i.e. If passed "/usr/local/myapp/help" and the current wxLocale is set to be "de", then look in "/usr/local/myapp/help/de/" first and fall back to "/usr/local/myapp/help" if that doesn't exist.

Parameters:

  | dir | directory name where to fine the help files

Returns:
  true on success

Reimplemented from wxHelpController.

virtual bool wxExtHelpController::KeywordSearch | ( | const wxString & | k,
|  | wxHelpSearchMode | mode = `wxHELP_SEARCH_ALL` |
| ) |  |  | `[virtual]`

Search comment/documentation fields in map file and present a list to chose from.

Parameters:

  | k | string to search for, empty string will list all entries
  | mode | optional parameter allows the search the index (wxHELP_SEARCH_INDEX) but this currently only supported by the wxHtmlHelpController.

Returns:
  true on success

Reimplemented from wxHelpController.

virtual bool wxExtHelpController::LoadFile | ( | const wxString & | file = `wxEmptyString` | ) | `[virtual]`

If file is "", reloads file given in Initialize.

Parameters:

  | file | Name of help directory.

Returns:
  true on success

Reimplemented from wxHelpController.

virtual void wxExtHelpController::OnQuit | ( |  | ) | `[virtual]`

Does nothing.

Reimplemented from wxHelpController.

virtual bool wxExtHelpController::Quit | ( |  | ) | `[virtual]`

Does nothing.

Reimplemented from wxHelpController.

virtual void wxExtHelpController::SetFrameParameters | ( | const wxString & | title,
|  | const wxSize & | size,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | bool | newFrameEachTime = `false` |
| ) |  |  | `[virtual]`

Allows one to override the default settings for the help frame.

Reimplemented from wxHelpController.

virtual void wxExtHelpController::SetViewer | ( | const wxString & | viewer = `wxEmptyString`,
|  | long | flags = `wxHELP_NETSCAPE` |
| ) |  |  | `[virtual]`

Tell it which browser to use.

The Netscape support will check whether Netscape is already running (by looking at the .netscape/lock file in the user's home directory) and tell it to load the page into the existing window.

Parameters:

  | viewer | The command to call a browser/html viewer.
  | flags | Set this to wxHELP_NETSCAPE if the browser is some variant of Netscape.

Reimplemented from wxHelpController.

|  | [ top ]